Page MenuHomePhabricator

[PowerPC] Enable paired vector type and intrinsics when MMA is disabled
ClosedPublic

Authored by bsaleil on Nov 19 2020, 1:27 PM.

Details

Summary

This patch enables the Clang type __vector_pair and its associated LLVM intrinsics even when MMA is disabled. With this patch, the type is now controller by the PPC paired-vector-memops option. The builtins and intrinsics will be renamed to drop the mma prefix in another patch.

Diff Detail

Event Timeline

bsaleil created this revision.Nov 19 2020, 1:27 PM
bsaleil requested review of this revision.Nov 19 2020, 1:27 PM
bsaleil added a reviewer: Restricted Project.
martong removed a subscriber: martong.Nov 23 2020, 1:46 AM
amyk added inline comments.Dec 4 2020, 2:47 PM
clang/lib/AST/ASTContext.cpp
1427

Is it better to do hasFeature() over PairedVectorMemops and HasMMA?

saghir accepted this revision.Dec 15 2020, 7:07 AM

LGTM.

This revision is now accepted and ready to land.Dec 15 2020, 7:07 AM
bsaleil added inline comments.Dec 15 2020, 10:26 AM
clang/lib/AST/ASTContext.cpp
1427

Target is a clang::TargetInfo here so there is no HasMMA method available. I'd need to add it, so I guess it's better to use directly hasFeature instead of adding PPC specific code in that class.

This revision was landed with ongoing or failed builds.Dec 15 2020, 1:14 PM
This revision was automatically updated to reflect the committed changes.
bsaleil marked an inline comment as done.